"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var io = require("socket.io-client");
var host = process.argv[2] || "http://localhost:8000";
var ns = "/chat";
var client = io(host + ns);
var channelNames = { en: "English", ru: "Russian" };
client.on("chatMessage", function (_a) {
    var sender = _a.sender, message = _a.message, channel = _a.channel;
    // assert typeof channel === "en" | "ru"
    // assert typeof message === string
    console.log(channelNames[channel] + ": " + sender + ": " + message);
});
client.emit("postMessage", { message: "Hello World", channel: "en" }, function (error, _response) {
    if (error)
        return console.error(error);
    // assert typeof _response === "ok" here
});
/* client.emit("postMessage", { message: "Hello World", channel: "es" }, () => {});
                                        ▲
              ┏━━━━━━━━━━━━━━━━━━━━━━━━━┻━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┓
              ┃ [ts] Type '"es"' is not assignable to type '"en" | "ru"'. ┃
              ┗━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┛ */
client.on("error", function (e) { return console.error("socket.io error", e); });
//# sourceMappingURL=client.js.map