import { ServerDefinition, SimpleNamespace, RootServer, ClientSideSocket } from "../../typedSocket";
export declare type ChatMessage = {
    sender: string;
    message: string;
    channel: "en" | "ru";
};
export interface MyServerDefinition extends ServerDefinition {
    namespaces: {
        "/chat": SimpleNamespace<{
            ServerMessages: {
                chatMessage: ChatMessage;
                history: ChatMessage[];
            };
            ClientRPCs: {
                postMessage: {
                    request: {
                        message: string;
                        channel: "en" | "ru";
                    };
                    response: "ok";
                    error: string;
                };
            };
            ClientMessages: {};
        }>;
    };
}
export declare type MyRootServer = RootServer<MyServerDefinition>;
export declare type TypedChatClient = ClientSideSocket<MyServerDefinition, "/chat">;
