"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var TypedClient_1 = require("../../TypedClient");
var host = process.argv[2] || "http://localhost:8001";
var ns = "/chat";
var channelNames = { en: "English", ru: "Russian" };
var ChatClientListener = /** @class */ (function (_super) {
    __extends(ChatClientListener, _super);
    function ChatClientListener() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChatClientListener.prototype.chatMessage = function (_a) {
        var sender = _a.sender, message = _a.message, channel = _a.channel;
        console.log(channelNames[channel] + ": " + sender + ": " + message);
    };
    ChatClientListener.prototype.history = function (msgs) {
        for (var _i = 0, msgs_1 = msgs; _i < msgs_1.length; _i++) {
            var msg = msgs_1[_i];
            this.chatMessage(msg);
        }
    };
    return ChatClientListener;
}(TypedClient_1.TypedClient));
function run() {
    return __awaiter(this, void 0, void 0, function () {
        var listener, res, rpc, res2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    listener = new ChatClientListener(host + ns);
                    return [4 /*yield*/, listener.socket.emitAsync("postMessage", {
                            message: "Hello World",
                            channel: "en",
                        })];
                case 1:
                    res = _a.sent();
                    console.assert(res === "ok");
                    rpc = listener.socket.rpc;
                    return [4 /*yield*/, rpc.postMessage({
                            message: "Hello World 2",
                            channel: "en",
                        })];
                case 2:
                    res2 = _a.sent();
                    console.assert(res2 === "ok");
                    return [2 /*return*/];
            }
        });
    });
}
run();
//# sourceMappingURL=client.js.map