"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runtimeSchema = void 0;
var t = require("io-ts");
var unchecked = function () { return t.any; };
exports.runtimeSchema = {
    // messages the server may send to the clients
    // since we generally trust the server, these are unchecked
    ServerMessages: {
        chatMessage: unchecked(),
        history: unchecked(),
    },
    // messages clients can send to the server, with a typed response
    // these are checked at runtime
    ClientRPCs: {
        postMessage: {
            request: t.strict({
                message: t.string,
                channel: t.union([t.literal("en"), t.literal("ru")]),
            }),
            response: unchecked(),
        },
    },
    // messages clients can send to the server (without a response)
    ClientMessages: {},
};
//# sourceMappingURL=common.js.map